% Conversion of column vector into class matrix n_patterns*n_classes
%
% For each i-th element of column vector, j-th column of matrix is a, where j is a class
% Othervise, element is 1-a (this is for training of multiclass 
%
%	INPUT:
%
%		class_vector	column vector of classes
%		a					value of column of class_matrix for appropriate class
%
%	OUTPUT:
%
%		class_matrix	n_patterns*N_class matrix
%
%
%	EXAMPLE:
%
%	class_vector=[1; 2; 3; 2];
%	a=0.9
%   class_matrix =
%
%          0.9          0.1          0.1
%          0.1          0.9          0.1
%          0.1          0.1          0.9
%          0.1          0.9          0.1

function [class_matrix]=class_matrix_gen1(class_vector,a,no_classes)
		no_patterns=size(class_vector,1);
		class_matrix=ones(no_patterns,no_classes)*(1-a);
      for i=1:no_classes
         indeces=find(class_vector==i);
         if(isempty(indeces)==0)
            class_matrix(indeces,i)=a;  %update only if it is not empty!!!!
         end   
      end   
      
return;


