function [meanv, stdv, ndata] = normalize(data, meanvv, stdvv)

[n c] = size(data);

if length(meanvv) == 0
   meanv = mean(data);
   stdv = std(data);
else
   meanv = meanvv;
   stdv = stdvv;
end

idx = find(stdv < 1e-10);
% if length(idx) > 0 
%     error('Some standard deviations are close to zero. Those inputs will NOT be transformed.');
% end

ndata = data;

e = ones(n, 1);
idx = setdiff(1 : c, idx);

for i = idx 
   x = data(:, i) - e * meanv(i);
   ndata(:, i) = x / stdv(i);
end

return;