clear

% open the file in read-only mode
f = fopen('adult.data', 'rb');

% initialize the data matrix
data = [];

% # of examples(lines) read
n1 = 0;
% # of examples with missing values
n2 = 0;

% read in the first example(line)
ln = fgetl(f);

% at the end of file, fgetl will return -1 (EOF)
while ischar(ln) & isempty(ln) == 0  
    
    if n1 == 5000
        break;
    end

    % if there are missing values (?), ignore current example. 
    if isempty(find(ln == '?'))
        
        % break down the current line into fields (in a STRING array)
        a = strread(ln, '%s', 'delimiter', ',');
        
        % convert the attributes (only the first three continuous ones are shown)
        age = str2num(a{1});
        fnlwgt = str2num(a{3});
        education_num = str2num(a{5});
        
        % convert the target variable
        if strcmp(a{15}, '>50K')
            target = 1;
        else
            target = 0;
        end
        
        % append it to data
        data = [data; age fnlwgt education_num target];
        
    else
        % at least one missing values
        n2 = n2 + 1;
    end
    
    % display progress
    n1 = n1 + 1;
    if mod(n1, 1000) == 0
        disp(sprintf('%d records read ...', n1));
    end
    
    % read in next example(line) 
    ln = fgetl(f);
end

% close the file
fclose(f);

disp(sprintf('%d examples read, %d examples with missing values', n1, n2));

% show the first 20 examples
data(1:20, :)

% show histograms
hist(data(:, 1))
hist(data(:, 2))
hist(data(:, 3))
hist(data(:, 4))

